<?php

namespace STM\Competition\Category;

use STM\StmFactory;

/**
 * Test class for CompetitionCategory.
 * Generated by PHPUnit on 2011-12-08 at 18:31:43.
 * @group competition_category
 */
class CompetitionCategoryTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $categories;

    protected function setUp() {
        $this->bad_values = array('', null, false, array());
        $this->categories = StmFactory::find()->CompetitionCategory->findAll();        
        CompetitionCategoryValidator::init();
    }

    protected function tearDown() {}

    public function testFind_all() {
        foreach ($this->categories as $category) {
            $this->assertTrue($category instanceof CompetitionCategory);
        }
    }

    public function testfindById() {
        foreach ($this->categories as $category) {
            $this->assertTrue(StmFactory::find()->CompetitionCategory->findById($category->getId()) instanceof CompetitionCategory);
        }
        foreach ($this->bad_values as $value) {
            $this->assertFalse(StmFactory::find()->CompetitionCategory->findById($value));
        }
    }

    public function testFind_subcategories() {
        foreach ($this->categories as $category) {
            $this->assertTrue(is_array(StmFactory::find()->CompetitionCategory->findSubcategories($category)));
        }
    }

    public function testCreate() {  
        foreach ($this->bad_values as $value) {
            $this->assertFalse(CompetitionCategory::create($value));
            $this->assertFalse(CompetitionCategory::create(array($value)));
        }
        // other tests in CompetitionCategoryValidatorTest
    }

    public function testExists_category() {
        
    }

    public function testDelete() {
        // cannot be tested
    }

    public function testUpdate() {
        foreach ($this->categories as $category) {
            foreach ($this->bad_values as $value) {
                $this->assertFalse($category->update($value));
            }
        }
        // other tests in CompetitionCategoryValidatorTest
    }

    public function testGet_id() {
        foreach ($this->categories as $category) {
            $this->assertTrue(is_int($category->getId()));
        }
    }

    public function testGet_name() {
        foreach ($this->categories as $category) {
            $this->assertTrue(is_string($category->getName()));
        }
    }

    public function testGet_description() {
        foreach ($this->categories as $category) {
            $this->assertTrue(is_string($category->getDescription()));
        }
    }

    public function testGet_parent_id() {
        foreach ($this->categories as $category) {
            $this->assertTrue(is_int($category->getCountCompetitions()) || is_null($category->getCountCompetitions()));
        }
    }

    public function testGet_count_childs() {
        foreach ($this->categories as $category) {
            $this->assertTrue(is_int($category->getCountChilds()));
        }
    }

    public function testGet_count_competitions() {
        foreach ($this->categories as $category) {
            $this->assertTrue(is_int($category->getCountCompetitions()));
        }
    }

    public function testTo_array() {
        foreach ($this->categories as $category) {
            $array = $category->toArray();
            $this->assertArrayHasKey('name', $array);
            $this->assertArrayHasKey('description', $array);
            $this->assertArrayHasKey('id_parent_category', $array);
            $this->assertArrayHasKey('count_childs', $array);            
            $this->assertArrayHasKey('count_competitions', $array);
            
            $this->assertFalse(isset($array['id']));
        }
    }

    public function test__toString() {
        foreach ($this->categories as $category) {
            $this->assertTrue(is_string($category->__toString()));
        }
    }

}

?>
